=== debian/changelog ===
rocsparse (6.4.3-1) unstable; urgency=medium

  * Upload to unstable
  * Remove use of ROCPRIM_USE_ARCH_CONVERSION as it is no longer
    supported.
  * Remove Maxime Chambonnet from uploaders
  * Update my email address
  * Enable fortify hardening flags
  * Use CMAKE_SKIP_INSTALL_RPATH to remove rpath from the install tree
    while still making use of it for build-time tests

 -- Cordell Bloor <cgmb@debian.org>  Mon, 03 Nov 2025 22:26:00 -0700

rocsparse (6.4.3-1~exp1) experimental; urgency=medium

  * New upstream version 6.4.3
  * Update d/gbp.conf to follow DEP-14
    https://dep-team.pages.debian.net/deps/dep14/
  * Update for new rocm-target-arch

 -- Christian Kastner <ckk@debian.org>  Sat, 09 Aug 2025 10:11:20 +0200

rocsparse (6.4.1-1~exp3) experimental; urgency=medium

  * Re-enable (redundant) arch-indep generation of test data.
    Fixes a FTBFS on arch-indep-only builds.

 -- Christian Kastner <ckk@debian.org>  Mon, 07 Jul 2025 22:01:05 +0200

rocsparse (6.4.1-1~exp2) experimental; urgency=medium

  * Improve the run-tests runner
  * Install test data to versioned directory
  * Use rocm-target-arch to select and document GPU arch
  * Add libamdhip64-dev to Build-Depends

 -- Christian Kastner <ckk@debian.org>  Mon, 07 Jul 2025 20:09:14 +0200
