=== debian/rules ===
#!/usr/bin/make -f
export CXX=hipcc
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export DEB_CXXFLAGS_MAINT_PREPEND = -gz
export VERBOSE=1

# filter incompatible options from affecting device code
CXXFLAGS := $(subst -fstack-protector-strong,-Xarch_host -fstack-protector-strong,$(CXXFLAGS))
CXXFLAGS := $(subst -fcf-protection,-Xarch_host -fcf-protection,$(CXXFLAGS))

CMAKE_FLAGS = \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_SKIP_INSTALL_RPATH=ON \
	-DAMDGPU_TARGETS="$(shell rocm-target-arch --sep ';')" \
	-DROCM_SYMLINK_LIBS=OFF \
	-DBUILD_FILE_REORG_BACKWARD_COMPATIBILITY=OFF \
	-DWITH_TEST_MATRICIES=OFF \
	-DBUILD_WITH_OFFLOAD_COMPRESS=OFF \
	-DINSTALL_TEST_DATA_DIR=/usr/share/librocsparse1-tests/data

ifeq (,$(filter nocheck,$(DEB_BUILD_PROFILES)))
CMAKE_FLAGS += \
	-DBUILD_CLIENTS_TESTS=ON
endif

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -e \
	; if [ -r /dev/kfd ] \
	; then obj-$(DEB_HOST_GNU_TYPE)/clients/staging/rocsparse-test \
	; else echo "W: /dev/kfd unreadable: no available AMD GPU." \
	;      echo "W: tests skipped." \
	; fi
endif

execute_before_dh_install-arch:
	:

override_dh_auto_configure-indep:
	:

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	http_proxy='127.0.0.1:9' \
	https_proxy='127.0.0.1:9' \
	ROCM_DOCS_REMOTE_DETAILS=http://localhost,local \
	latest_version= \
	release_candidate= \
	sphinx-build -v -b html docs html
endif
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	python3 clients/common/rocsparse_gentest.py \
		-I clients/include \
		clients/tests/rocsparse_test.yaml \
		-o rocsparse_test.data
endif

override_dh_auto_test-indep:
	:

override_dh_auto_install-indep:
	:

override_dh_dwz:
	:

override_dh_gencontrol:
	dh_gencontrol -- -Vrocm:GPU-Architecture="$(shell rocm-target-arch)"
