=== debian/tests/control ===
Test-Command: rocm-test-launcher /usr/libexec/rocm/librocsparse1-tests/run-tests
Features: test-name=librocsparse1-tests
Depends: pkg-rocm-tools, librocsparse1-tests
Restrictions: skippable, allow-stderr
Architecture: amd64 arm64 ppc64el
